const USE_GLOBAL=`
//const _G = globalThis;
      _G._typof          = (o,tname)                                => typeof(o)===tname;                
      _G._istof          = (a,b)                                    => (a instanceof b);      

      _G._is_fin         = isFinite; 
      _G._is_nan         = isNaN; 			  
      _G._is_infi        = (n)                                      => !isFinite(n);                                                      
      _G._is_pos_zero    = (z)                                      => (1/z)===+Infinity;                
      _G._is_neg_zero    = (z)                                      => (1/z)===-Infinity;
      _G._is_ary_idx     = (i)                                      => i>=0&&i<=2**32-2;                 
      _G._is_ary_len     = (i)                                      => i>=0&&i<=2**32-1;  

      _G._B              = Boolean;                                
      _G._N              = Number;                                 
      _G._S              = String;                                 
      _G._BI             = BigInt;                                 
      _G._Y              = Symbol;                                 
      

      _G._O              = Object;
      _G._RE             = RegExp;
      _G._DT             = Date;

      _G._A              = Array;                                  
      _G._MP             = Map;                                    
      _G._ST             = Set;                                    
      
      _G._WMP            = WeakMap;                                
      _G._WST            = WeakSet;                                
      _G._WREF           = WeakRef;         


      _G._F              = Function;
      _G._P              = Promise;
      _G._X              = Proxy;

      _G._DV             = DataView;
      _G._AB             = ArrayBuffer;                            
      _G._BUF            = Buffer;  
      _G._SAB            = SharedArrayBuffer;
      
      _G._U8A            = Uint8Array;                             
      _G._U8CA           = Uint8ClampedArray;                      
      _G._U16A           = Uint16Array;                            
      _G._U32A           = Uint32Array;                            
      _G._I8A            = Int8Array;                              
      _G._I16A           = Int16Array;                             
      _G._I32A           = Int32Array;                             
      _G._F32A           = Float32Array;                           
      _G._F64A           = Float64Array;                           
      _G._BU64A          = BigUint64Array;                         
      _G._BI64A          = BigInt64Array;                          
      
      _G._ER             = Error; 
      _G._AGGER          = AggregateError;                         
      _G._EVLER          = EvalError;                              
      _G._REFER          = ReferenceError;                         
      _G._RNGER          = RangeError;                             
      _G._STXER          = SyntaxError;                            
      _G._TYPER          = TypeError;                              
      _G._URIER          = URIError;
`;


const USE_CONST=`

const  _is_fin         = isFinite;
const  _is_nan         = isNaN;
const  _is_infi        = (n)                                      => !isFinite(n);
const  _is_pos_zero    = (z)                                      => (1/z)===+Infinity;
const  _is_neg_zero    = (z)                                      => (1/z)===-Infinity;
const  _is_ary_idx     = (i)                                      => i>=0&&i<=2**32-2;
const  _is_ary_len     = (i)                                      => i>=0&&i<=2**32-1;

const  _typof          = (o,tname)                                => typeof(o)===tname;
const  _istof          = (a,b)                                    => (a instanceof b);

//_un

const  _B              = Boolean;
    //_t _f
const  _N              = Number;
const  _S              = String;
const  _BI             = BigInt;
const  _Y              = Symbol;

const  _O              = Object;
    const  _RE             = RegExp;
    const  _DT             = Date;

    //container
    const  _A              = Array;
    const  _MP             = Map;
    const  _ST             = Set;
    //// dict

    //flike
    const  _F              = Function;
        //// cls func lambda cmthd omethd , acallable
    //special
    const  _P              = Promise;
    const  _X              = Proxy;

    //weak
    const  _WMP            = WeakMap;
    const  _WST            = WeakSet;
    const  _WREF           = WeakRef;

    //buffer-like
    const  _DV             = DataView;
    const  _AB             = ArrayBuffer;
    const  _SAB            = SharedArrayBuffer;
    const  _BUF            = Buffer;

    //typed-array
    const  _U8A            = Uint8Array;
    const  _U8CA           = Uint8ClampedArray;
    const  _U16A           = Uint16Array;
    const  _U32A           = Uint32Array;
    const  _I8A            = Int8Array;
    const  _I16A           = Int16Array;
    const  _I32A           = Int32Array;
    const  _F32A           = Float32Array;
    const  _F64A           = Float64Array;
    const  _BU64A          = BigUint64Array;
    const  _BI64A          = BigInt64Array;

    //error
    const  _ER             = Error;
        const  _AGGER          = AggregateError;
        const  _EVLER          = EvalError;
        const  _REFER          = ReferenceError;
        const  _RNGER          = RangeError;
        const  _STXER          = SyntaxError;
        const  _TYPER          = TypeError;
        const  _URIER          = URIError;
/*
module.exports = {
    // tool
    _typof,_istof,
    //
    _is_fin,_is_nan,_is_infi,_is_pos_zero,_is_neg_zero,_is_ary_idx,_is_ary_len,
    ////
    _B,_N,_S,_BI,_Y,
    //
    _O,
    _RE,_DT,
    _A,_MP,_ST,
    _WMP,_WST,_WREF,

    _F,
    _P,_X,

    _AB,_BUF,_DV,_SAB,

    _U8A,_U8CA,_U16A,_U32A,_I8A,_I16A,_I32A,_F32A,_F64A,_BU64A,_BI64A,
    _ER,
        _AGGER,_EVLER,_REFER,_RNGER,_STXER,_TYPER,_URIER   
}
 */
`



module.exports = {
    USE_GLOBAL,
    USE_CONST
}
